## ddcui 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

message(STATUS "cmake version: ${CMAKE_VERSION}")
# message(VERBOSE) requires cmake 3.15
if (CMAKE_VERSION VERSION_LESS 15) 
   set(VERBOSE STATUS)
else()
   set(VERBOSE VERBOSE)
endif()

set(ddcui_qt_version         5.5)
set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
set(ddcui_libddcutil_version 1.2.2)
set(cmake_build_type_default "RelWithDebInfo")

message(${VERBOSE} "Required Minimum Versions:")
message(${VERBOSE} "  ddcui_qt_version:          ${ddcui_qt_version}" )
message(${VERBOSE} "  ddcui_qlib_version:        ${ddcui_glib_version}" )
message(${VERBOSE} "  ddcui_libddcutil_version:  ${ddcui_libddcutil_version}" ) 

option(USE_CCACHE "Use ccache" ON)
message(STATUS "USE_CCACHE: ${USE_CCACHE}" )

string(APPEND CMAKE_MODULE_PATH  ${CMAKE_SOURCE_DIR}) 
include(validate_CMAKE_BUILD_TYPE)


project(ddcui VERSION 0.3.0 LANGUAGES C CXX)

message(STATUS "Build type is: ${CMAKE_BUILD_TYPE} (CMAKE_BUILD_TYPE)")
message(${VERBOSE} "   CMAKE_CXX_FLAGS:                ${CMAKE_CXX_FLAGS}" )
message(${VERBOSE} "   CMAKE_C_FLAGS:                  ${CMAKE_C_FLAGS}" )
message(${VERBOSE} "   CMAKE_CXX_FLAGS_DEBUG:          ${CMAKE_CXX_FLAGS_DEBUG}" )
message(${VERBOSE} "   CMAKE_C_FLAGS_DEBUG:            ${CMAKE_C_FLAGS_DEBUG}" )
message(${VERBOSE} "   CMAKE_CXX_FLAGS_RELWITHDEBINFO: ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}" )
message(${VERBOSE} "   CMAKE_C_FLAGS_RELWITHDEBINFO:   ${CMAKE_C_FLAGS_RELWITHDEBINFO}" )
message(${VERBOSE} "   CMAKE_CXX_FLAGS_RELEASE:        ${CMAKE_CXX_FLAGS_RELEASE}" )
message(${VERBOSE} "   CMAKE_C_FLAGS_RELEASE:          ${CMAKE_C_FLAGS_RELEASE}" )

# message(${VERBOSE} "Project variables:")
# message(${VERBOSE} "  PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}" )
# message(${VERBOSE} "  PROJECT_BINARY_DIR ${PROJECT_BINARY_DIR}" )

message(STATUS "Source directory: ${CMAKE_SOURCE_DIR} (CMAKE_SOURCE_DIR)" )
message(STATUS "Build directory:  ${CMAKE_BINARY_DIR} (CMAKE_BINARY_DIR)" )

if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} ) 
   message(WARNING "Attempting to build in source directory.")
   if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
      message(WARNING "Use -B option to set the build directory.")
   endif()
endif()
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})

# add_compile_definitions(QT_NO_DEBUG)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND AND USE_CCACHE)
     message( STATUS "Using ccache to improve build performance" )
     set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
endif()

# set (coverity_cflags --type_traits_helpers)
# set (coverity_cflags --no_predefined_feature_test_macros)
# set (COVERITY_DUMMIES OFF)

message(${VERBOSE} "Significant environment variables:")
message(${VERBOSE} "  INCLUDE:                  $ENV{INCLUDE}")
message(${VERBOSE} "  LD_LIBRARY_PATH:          $ENV{LD_LIBARARY_PATH}")
message(${VERBOSE} "  PKG_CONFIG_PATH:          $ENV{PKG_CONFIG_PATH} ")
message(${VERBOSE} "cmake paths:")
message(${VERBOSE} "  CMAKE_MODULE_PATH:        ${CMAKE_MODULE_PATH}")
message(${VERBOSE} "  CMAKE_PREFIX_PATH:        ${CMAKE_PREFIX_PATH}")
message(${VERBOSE} "  CMAKE_BINARY_DIR:         ${CMAKE_BINARY_DIR}" )
message(${VERBOSE} "  CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}" )
message(${VERBOSE} "  EXCECUTABLE_OUTPUT_PATH:  ${EXECUTABLE_OUTPUT_PATH}" )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find includes in corresponding build directories, needed for config.h
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
message( ${VERBOSE} "Qt settings:")
message( ${VERBOSE} "  CMAKE_AUTOUIC:           ${CMAKE_AUTOUIC}")
message( ${VERBOSE} "  CMAKE_AUTOMOC:           ${CMAKE_AUTOMOC}")
message( ${VERBOSE} "  CMAKE_AUTORCC:           ${CMAKE_AUTORCC}")
# message( ${VERBOSE} "AUTOGEN_BUILD_DIR:       ${AUTOGEN_BUILD_DIR}") overrides default location

set(QT5_LIBRARIES Qt5::Widgets )
# Ensures all Qt componenets have same version: 
find_package(Qt5 ${ddcui_qt_version} COMPONENTS Core Widgets Gui Help REQUIRED)
message( ${VERBOSE} "Qt directories:")
message( ${VERBOSE} "  Qt5Widgets_INCLUDE_DIRS:  ${Qt5Widgets_INCLUDE_DIRS}" )
message( ${VERBOSE} "  Qt5Core_INCLUDE_DIRS:     ${Qt5Core_INCLUDE_DIRS}"    )
message( ${VERBOSE} "  Qt5Gui_INCLUDE_DIRS:      ${Qt5Gui_INCLUDE_DIRS}"     )
message( ${VERBOSE} "  Qt5Help_INCLUDE_DIRS:     ${Qt5Help_INCLUDE_DIRS}"    )

find_package (PkgConfig REQUIRED )
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=${ddcui_glib_version})
pkg_check_modules(DDCUTIL REQUIRED ddcutil>=${ddcui_libddcutil_version})
# set(DDCUTIL_LIBRARY_DIRS /usr/lib/x86_64-linux-gnu/)   # hack for testing
message( ${VERBOSE} "Set by pkg-config:" )
message( ${VERBOSE} "  GLIB2_INCLUDE_DIRS:       ${GLIB2_INCLUDE_DIRS}"   )
message( ${VERBOSE} "  GLIB2_LIBRARIES:          ${GLIB2_LIBRARIES}"      )
message( ${VERBOSE} "  DDCUTIL_INCLUDE_DIRS:     ${DDCUTIL_INCLUDE_DIRS}" )
message( ${VERBOSE} "  DDCUTIL_LIBRARY_DIRS:     ${DDCUTIL_LIBRARY_DIRS}" )
message( ${VERBOSE} "  DDCUTIL_LIBRARIES:        ${DDCUTIL_LIBRARIES}"    )

configure_file(cconfig.h.in config.h)

set(SOURCES
    src/c_util/data_structures.c
    src/c_util/ddcutil_config_file.c
    src/c_util/file_util_base.c
    src/c_util/glib_util.c
    src/c_util/debug_util.c
    src/c_util/report_util.c
    src/c_util/simple_ini_file.c
    src/c_util/string_util.c
    src/c_util/xdg_util.c

    src/base/core.cpp 
    src/base/ddca_utils.cpp 
    src/base/ddcui_parms.cpp
    src/base/feature_list.c
    src/base/feature_selector.cpp 
    src/base/global_state.cpp
    src/base/monitor.h
    src/base/nc_values_state.cpp
    src/base/user_interface_options_state.cpp
    src/base/widget_debug.cpp 

    src/core_widgets/hex_number_validator.cpp
    src/core_widgets/hline_widget.cpp 
    src/core_widgets/number_entry_widget.cpp
    src/core_widgets/spin_slider.cpp

    src/cmdline/ddcui_cmd_parser.c
    src/cmdline/ddcui_cmd_parser_aux.c
    src/cmdline/ddcui_parsed_cmd.c

    src/nongui/ddca_simulator.cpp
    src/nongui/feature_base_model.cpp 
    src/nongui/feature_value.cpp 
    src/nongui/msgbox_queue.cpp
    src/nongui/vcprequest.cpp 
    src/nongui/vcpthread.cpp 

    src/monitor_desc/monitor_desc_actions.cpp
    src/monitor_desc/monitor_desc_ui.cpp 

    src/feature_value_widgets/value_2button_widget.cpp 
    src/feature_value_widgets/value_base_widget.cpp
    src/feature_value_widgets/value_bytes_widget.cpp
    src/feature_value_widgets/value_cnc_widget_x14.cpp
    src/feature_value_widgets/value_nc_widget.cpp 
    src/feature_value_widgets/value_ncplus_widget.cpp
    src/feature_value_widgets/value_new_cont_widget.cpp 
    src/feature_value_widgets/value_reset_widget.cpp 
    src/feature_value_widgets/value_simple_cont_widget.cpp
    src/feature_value_widgets/value_special_widget_x62.cpp
    src/feature_value_widgets/value_stacked_widget.cpp 
    src/feature_value_widgets/value_std_widget.cpp 

    src/feature_scrollarea/feature_widget.cpp 
    src/feature_scrollarea/feature_widget_header.cpp 
    src/feature_scrollarea/features_scrollarea.cpp 
    src/feature_scrollarea/features_scrollarea_contents.cpp 
    src/feature_scrollarea/features_scrollarea_ui.cpp 
    src/feature_scrollarea/features_scrollarea_view.cpp

    src/help/help_dialog.cpp
    src/help/help_browser.cpp
    ddcui.qrc

    src/action_dialogs/debug_actions_dialog.cpp
    src/option_dialogs/feature_selection_dialog.cpp 
    src/option_dialogs/nc_values_dialog.cpp
    src/option_dialogs/user_interface_options_dialog.cpp

    src/main/main.cpp
    src/main/mainwindow.cpp 
    src/main/mainwindow_ui.cpp
    src/main/monitor.cpp 
    src/main/msgbox_thread.cpp
)

# file(GLOB dummy_SOURCES src/dummies/*.cpp)
# if (COVERITY_DUMMIES) 
#    set (SOURCES ${SOURCES} ${dummy_SOURCES} )
# endif()

set(UI_SOURCES
    src/option_dialogs/feature_selection_dialog.ui
    src/option_dialogs/nc_values_dialog.ui
    src/option_dialogs/user_interface_options_dialog.ui
    src/action_dialogs/debug_actions_dialog.ui
   )

# must come before add_executable(): 
link_directories(${DDCUTIL_LIBRARY_DIRS})

# qt5_wrap_ui(UI_GENERATED_HEADERS ${UI_SOURCES})
# add_executable(ddcui ${SOURCES} ${UI_GENERATED_HEADERS})
add_executable(ddcui ${SOURCES})

# -Wno-format-pedantic -Wno-sign-compare -std=c++20 -Wno-format -pedantic -Wextra -Wall
# set(more_options -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-non-pod-varargs  )
target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags})
# add_compile_options(-Og -H V=1)

# redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
#            ${Qt5Help_INCLUDE_DIRS} is a superset of them all 
target_include_directories(ddcui SYSTEM PRIVATE 
                                 ${Qt5Help_INCLUDE_DIRS}
                                 ${GLIB2_INCLUDE_DIRS} 
                                 ${DDCUTIL_INCLUDE_DIRS})

target_include_directories(ddcui PRIVATE src)

get_property(dirs TARGET ddcui PROPERTY INCLUDE_DIRECTORIES)
message( ${VERBOSE} "INCLUDE_DIRECTORIES:     ${dirs}" )
message( ${VERBOSE} "Expanded:" )
foreach(d ${dirs})
  message(${VERBOSE} "  ${d}")
endforeach()

# Use the Widgets module from Qt 5.
target_link_libraries(ddcui Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})


### make clean

# ADDITIONAL_MAKE_CLEAN_FILES(  ... )


### make install

# define GNU standard installation directories
include(GNUInstallDirs)
message( ${VERBOSE} "GNU installation directories:")
message( ${VERBOSE} "  CMAKE_INSTALL_BINDIR:        ${CMAKE_INSTALL_BINDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_PREFIX:        ${CMAKE_INSTALL_PREFIX}" )
message( ${VERBOSE} "  CMAKE_INSTALL_DATATROOTDIR:  ${CMAKE_INSTALL_DATAROOTDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_SYSCONFDIR:    ${CMAKE_INSTALL_SYSCONFDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_LIBDIR:        ${CMAKE_INSTALL_LIBDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_LIBEXECDIR:    ${CMAKE_INSTALL_LIBEXECDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_INCLUDEDIR:    ${CMAKE_INSTALL_INCLUDEDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_INFODIR:       ${CMAKE_INSTALL_INFODIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_MANDIR:        ${CMAKE_INSTALL_MANDIR}" )
message( ${VERBOSE} "  CMAKE_INSTALL_DOCDIR:        ${CMAKE_INSTALL_DOCDIR}" )

# Special handling for openSuse and SLE. 
# Normally, documentation files are stored in directory /usr/share/doc/ddcui. 
# The value of CMAKE_INSTALL_DOCDIR is "share/doc/ddcui".  However, on SuSE
# systems, doc files are instead stored in directory /usr/share/doc/packages/ddcui.
# However, CMAKE_INSTALL_DOCDIR is still set to "share/doc/ddcui". 
# The following code tries to determine if we're running on a system where
# the value of CMAKE_INSTALL_DOCDIR needs to be changed to "share/doc/packages/ddcui". 
# For SuSe (and Fedora) file /etc/os-release is automatically installed
# from the default packages.  However, for SLE it is not, so the os-release check
# is not possible. Instead, a heuristic test is performed.

set(suse_special_case FALSE)
if(EXISTS "/etc/os-release")
   message(STATUS "File /etc/os-release found")
   file(STRINGS "/etc/os-release" id_line REGEX "^ID=(.*)$") 
   string(STRIP ${id_line} id_line)
   
   # Testcases:
   # set(id_line "ID=\"opensuse-leap\"")
   # set(id_line "ID=opensuse-leap")
   # message(STATUS "id_line: |${id_line}|")
   
   string(SUBSTRING ${id_line} 3 -1 distro_name0)
   string(SUBSTRING ${distro_name0} 0 1 ch)
   if (ch STREQUAL "\"") 
      string(LENGTH ${distro_name0} len)
      math(EXPR l2 "${len}-2")
      string(SUBSTRING ${distro_name0} 1 ${l2} distro_name0)
   endif()
   string(SUBSTRING ${distro_name0} 0 8 distro_name)
   message(STATUS "Distribution: distro_name = |${distro_name}|")
   if( distro_name STREQUAL "opensuse" )
      # message(STATUS "distro_name matches opensuse") 
      set(suse_special_case TRUE)

=== debian/changelog ===
ddcui (0.3.0-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:41:51 +1100

ddcui (0.3.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:10:29 +0000

ddcui (0.3.0-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:11:24 +0000

ddcui (0.3.0-1) unstable; urgency=medium

  * New upstream release

  * debian/control
    * increment Standards-Version to 4.6.1

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Mon, 25 Jul 2022 05:00:00 -0400

ddcui (0.2.1-1) unstable; urgency=medium

  * Initial Debian release. (Closes: #1004840)

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Mon, 31 Jan 2022 05:00:00 -0400

=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sanford Rockowitz <rockowitz@minsoft.com>
Build-Depends: debhelper      (>= 13),
               pkg-config,
               cmake,
               libglib2.0-dev,
               libxrandr-dev,
               qtbase5-dev,
               qttools5-dev,
               libddcutil4 (>= 1.2.2),
               libddcutil-dev (>= 1.2.2)
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: http://www.ddcutil.com

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GUI for ddcutil
 This package provides a graphical user interface for ddccutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-Wall -pedantic

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs -k  CHANGELOG.md

override_dh_auto_configure:
	dh_auto_configure -- --log-level=VERBOSE

## ddcui 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 set(ddcui_qt_version         5.5)
 set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
-set(ddcui_libddcutil_version 1.2.2)
+set(ddcui_libddcutil_version 2.0.0)
 set(cmake_build_type_default "RelWithDebInfo")
 
 message(${VERBOSE} "Required Minimum Versions:")
@@ -19,15 +19,23 @@
 message(${VERBOSE} "  ddcui_libddcutil_version:  ${ddcui_libddcutil_version}" ) 
 
 option(USE_CCACHE "Use ccache" ON)
-message(STATUS "USE_CCACHE: ${USE_CCACHE}" )
-
-string(APPEND CMAKE_MODULE_PATH  ${CMAKE_SOURCE_DIR}) 
+message(STATUS "USE_CCACHE:                ${USE_CCACHE}" )
+
+option(ASAN "Build for ASAN" OFF)
+message(STATUS "ASAN:                      ${ASAN}")
+
+option(DDCUTIL_PROJECT_DIR "Root directory of ddcutil project" OFF)
+message(STATUS "DDCUTIL_PROJECT_DIR:       ${DDCUTIL_PROJECT_DIR}"  )
+
+string(APPEND CMAKE_MODULE_PATH  ${CMAKE_SOURCE_DIR} ) 
+
 include(validate_CMAKE_BUILD_TYPE)
 
-
-project(ddcui VERSION 0.3.0 LANGUAGES C CXX)
+project(ddcui VERSION 0.5.0 LANGUAGES C CXX)
 
 message(STATUS "Build type is: ${CMAKE_BUILD_TYPE} (CMAKE_BUILD_TYPE)")
+message(${VERBOSE} "   CMAKE_C_COMPILER:               ${CMAKE_C_COMPILER}" )
+message(${VERBOSE} "   CMAKE_CXX_COMPILER:             ${CMAKE_CXX_COMPILER}" )
 message(${VERBOSE} "   CMAKE_CXX_FLAGS:                ${CMAKE_CXX_FLAGS}" )
 message(${VERBOSE} "   CMAKE_C_FLAGS:                  ${CMAKE_C_FLAGS}" )
 message(${VERBOSE} "   CMAKE_CXX_FLAGS_DEBUG:          ${CMAKE_CXX_FLAGS_DEBUG}" )
@@ -44,6 +52,21 @@
 message(STATUS "Source directory: ${CMAKE_SOURCE_DIR} (CMAKE_SOURCE_DIR)" )
 message(STATUS "Build directory:  ${CMAKE_BINARY_DIR} (CMAKE_BINARY_DIR)" )
 
+  execute_process(
+      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+      COMMAND git branch --show-current 2>/dev/null
+      OUTPUT_VARIABLE DDCUI_GIT_BRANCH
+      RESULT_VARIABLE GIT_CMD_STATUS
+   )
+   # message (${VERBOSE} " result_variable: ${GIT_CMD_STATUS}")
+   if (${GIT_CMD_STATUS} STREQUAL "0")
+      string(LENGTH ${DDCUI_GIT_BRANCH} N)
+      math(EXPR lastpos "${N}-1")
+      string(SUBSTRING ${DDCUI_GIT_BRANCH} 0 ${lastpos} DDCUI_GIT_BRANCH)
+      message( ${VERBOSE} "ddcui git branch:   ${DDCUI_GIT_BRANCH}")
+   else() 
+      message( ${VERBOSE} "ddcui source is not managed by git")
+   endif()
 if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} ) 
    message(WARNING "Attempting to build in source directory.")
    if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
@@ -63,6 +86,11 @@
 # set (coverity_cflags --type_traits_helpers)
 # set (coverity_cflags --no_predefined_feature_test_macros)
 # set (COVERITY_DUMMIES OFF)
+
+if (ASAN)
+   set (asan_flags -g -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer)
+   set (ASAN_LIBRARY asan)
+endif()
 
 message(${VERBOSE} "Significant environment variables:")
 message(${VERBOSE} "  INCLUDE:                  $ENV{INCLUDE}")
@@ -102,11 +130,42 @@
 
 find_package (PkgConfig REQUIRED )
 pkg_check_modules(GLIB2 REQUIRED glib-2.0>=${ddcui_glib_version})
-pkg_check_modules(DDCUTIL REQUIRED ddcutil>=${ddcui_libddcutil_version})
-# set(DDCUTIL_LIBRARY_DIRS /usr/lib/x86_64-linux-gnu/)   # hack for testing
+
+if ( (DDCUTIL_PROJECT_DIR STREQUAL "OFF")) 
+   message( ${VERBOSE} "Locating ddcutil files using pkg_check_modules")
+   pkg_check_modules(DDCUTIL REQUIRED ddcutil>=${ddcui_libddcutil_version})
+else()
+   message( ${VERBOSE} "Using ddcutil files from ${DDCUTIL_PROJECT_DIR}")
+   string(LENGTH ${DDCUTIL_PROJECT_DIR} N)
+   math(EXPR lastpos "${N}-1")
+   string(SUBSTRING ${DDCUTIL_PROJECT_DIR} ${lastpos} 1 CH)
+   if ( ( ${CH} STREQUAL /) )
+      string(SUBSTRING ${DDCUTIL_PROJECT_DIR} 0 ${lastpos} DDCUTIL_PROJECT_DIR)
+      message( ${VERBOSE} "Adjusted DDCUTIL_PROJECT_DIR:  ${DDCUTIL_PROJECT_DIR}")
+   endif()
+   set(DDCUTIL_INCLUDE_DIRS ${DDCUTIL_PROJECT_DIR}/src/public)
+   set(DDCUTIL_LIBRARY_DIRS ${DDCUTIL_PROJECT_DIR}/src/.libs)
+   set(DDCUTIL_LIBRARIES ddcutil)
+   execute_process(
+      WORKING_DIRECTORY ${DDCUTIL_PROJECT_DIR}
+      COMMAND git branch --show-current
+      OUTPUT_VARIABLE DDCUTIL_GIT_BRANCH
+      RESULT_VARIABLE GIT_CMD_STATUS
+   )
+   if (${GIT_CMD_STATUS} STREQUAL "0")
+      string(LENGTH ${DDCUTIL_GIT_BRANCH} N)
+      math(EXPR lastpos "${N}-1")
+      string(SUBSTRING ${DDCUTIL_GIT_BRANCH} 0 ${lastpos} DDCUTIL_GIT_BRANCH)
+      message( ${VERBOSE} "ddcutil git branch:   ${DDCUTIL_GIT_BRANCH}")
+   else() 
+      message( ${VERBOSE} "ddcui source is not managed by git")
+   endif()
+endif()
+
 message( ${VERBOSE} "Set by pkg-config:" )
 message( ${VERBOSE} "  GLIB2_INCLUDE_DIRS:       ${GLIB2_INCLUDE_DIRS}"   )
 message( ${VERBOSE} "  GLIB2_LIBRARIES:          ${GLIB2_LIBRARIES}"      )
+
 message( ${VERBOSE} "  DDCUTIL_INCLUDE_DIRS:     ${DDCUTIL_INCLUDE_DIRS}" )
 message( ${VERBOSE} "  DDCUTIL_LIBRARY_DIRS:     ${DDCUTIL_LIBRARY_DIRS}" )
 message( ${VERBOSE} "  DDCUTIL_LIBRARIES:        ${DDCUTIL_LIBRARIES}"    )
@@ -116,15 +175,17 @@
 set(SOURCES
     src/c_util/data_structures.c
     src/c_util/ddcutil_config_file.c
+    src/c_util/debug_util.c
+    src/c_util/error_info.c
     src/c_util/file_util_base.c
     src/c_util/glib_util.c
-    src/c_util/debug_util.c
     src/c_util/report_util.c
     src/c_util/simple_ini_file.c
     src/c_util/string_util.c
     src/c_util/xdg_util.c
 
-    src/base/core.cpp 
+    src/base/ddcui_core_aux.c
+    src/base/ddcui_core.cpp 
     src/base/ddca_utils.cpp 
     src/base/ddcui_parms.cpp
     src/base/feature_list.c
@@ -211,17 +272,20 @@
 
 # -Wno-format-pedantic -Wno-sign-compare -std=c++20 -Wno-format -pedantic -Wextra -Wall
 # set(more_options -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-non-pod-varargs  )
-target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags})
+target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags} ${asan_flags})
 # add_compile_options(-Og -H V=1)
 
 # redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
 #            ${Qt5Help_INCLUDE_DIRS} is a superset of them all 
-target_include_directories(ddcui SYSTEM PRIVATE 
+target_include_directories(ddcui SYSTEM PRIVATE
                                  ${Qt5Help_INCLUDE_DIRS}
                                  ${GLIB2_INCLUDE_DIRS} 
                                  ${DDCUTIL_INCLUDE_DIRS})
 
 target_include_directories(ddcui PRIVATE src)
+
+# Use the Widgets module from Qt 5.
+target_link_libraries(ddcui ${ASAN_LIBRARY} Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})
 
 get_property(dirs TARGET ddcui PROPERTY INCLUDE_DIRECTORIES)
 message( ${VERBOSE} "INCLUDE_DIRECTORIES:     ${dirs}" )
@@ -230,62 +294,7 @@
   message(${VERBOSE} "  ${d}")
 endforeach()
 
-# Use the Widgets module from Qt 5.
-target_link_libraries(ddcui Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})
-
-
-### make clean
-
-# ADDITIONAL_MAKE_CLEAN_FILES(  ... )
-
-
-### make install
-
-# define GNU standard installation directories
-include(GNUInstallDirs)
-message( ${VERBOSE} "GNU installation directories:")
-message( ${VERBOSE} "  CMAKE_INSTALL_BINDIR:        ${CMAKE_INSTALL_BINDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_PREFIX:        ${CMAKE_INSTALL_PREFIX}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_DATATROOTDIR:  ${CMAKE_INSTALL_DATAROOTDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_SYSCONFDIR:    ${CMAKE_INSTALL_SYSCONFDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_LIBDIR:        ${CMAKE_INSTALL_LIBDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_LIBEXECDIR:    ${CMAKE_INSTALL_LIBEXECDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_INCLUDEDIR:    ${CMAKE_INSTALL_INCLUDEDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_INFODIR:       ${CMAKE_INSTALL_INFODIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_MANDIR:        ${CMAKE_INSTALL_MANDIR}" )
-message( ${VERBOSE} "  CMAKE_INSTALL_DOCDIR:        ${CMAKE_INSTALL_DOCDIR}" )
-
-# Special handling for openSuse and SLE. 
-# Normally, documentation files are stored in directory /usr/share/doc/ddcui. 
-# The value of CMAKE_INSTALL_DOCDIR is "share/doc/ddcui".  However, on SuSE
-# systems, doc files are instead stored in directory /usr/share/doc/packages/ddcui.
-# However, CMAKE_INSTALL_DOCDIR is still set to "share/doc/ddcui". 
-# The following code tries to determine if we're running on a system where
-# the value of CMAKE_INSTALL_DOCDIR needs to be changed to "share/doc/packages/ddcui". 
-# For SuSe (and Fedora) file /etc/os-release is automatically installed
-# from the default packages.  However, for SLE it is not, so the os-release check
-# is not possible. Instead, a heuristic test is performed.
-
-set(suse_special_case FALSE)
-if(EXISTS "/etc/os-release")
-   message(STATUS "File /etc/os-release found")
-   file(STRINGS "/etc/os-release" id_line REGEX "^ID=(.*)$") 
-   string(STRIP ${id_line} id_line)
-   
-   # Testcases:
-   # set(id_line "ID=\"opensuse-leap\"")
-   # set(id_line "ID=opensuse-leap")
-   # message(STATUS "id_line: |${id_line}|")
-   
-   string(SUBSTRING ${id_line} 3 -1 distro_name0)
-   string(SUBSTRING ${distro_name0} 0 1 ch)
-   if (ch STREQUAL "\"") 
-      string(LENGTH ${distro_name0} len)
-      math(EXPR l2 "${len}-2")
-      string(SUBSTRING ${distro_name0} 1 ${l2} distro_name0)
-   endif()
-   string(SUBSTRING ${distro_name0} 0 8 distro_name)
-   message(STATUS "Distribution: distro_name = |${distro_name}|")
-   if( distro_name STREQUAL "opensuse" )
-      # message(STATUS "distro_name matches opensuse") 
-      set(suse_special_case TRUE)
+get_property(dirs TARGET ddcui PROPERTY LINK_DIRECTORIES)
+message( ${VERBOSE} "LINK_DIRECTORIES:     ${dirs}" )
+message( ${VERBOSE} "Expanded:" )
+foreach(d ${dirs})

=== debian/changelog ===
ddcui (0.5.0-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * depends on libddcutil5

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 17 Jan 2024 05:00:00 -0400

ddcui (0.4.1-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * bump standards version to 4.6.2

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 27 Sep 2023 05:00:00 -0400

ddcui (0.3.0-1) focal; urgency=medium

  * New upstream release.

  * debian/control
    * bump standards version to 4.6.1

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 23 Jul 2022 05:00:00 -0400

ddcui (0.2.1-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Fri, 28 Jan 2022 05:00:00 -0400

ddcui (0.2.0-1) focal; urgency=low

  * Initial beta release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sun, 31 Jan 2021 05:00:00 -0400

ddcui (0.1.1-2) focal; urgency=low

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 13 Jun 2020 05:00:00 -0400

=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Sanford Rockowitz <rockowitz@minsoft.com>
Build-Depends: debhelper      (>= 10),
               pkg-config,
               cmake          (>= 3.10),
               qtbase5-dev    (>= 5.5),
               qttools5-dev   (>= 5.5),
               libglib2.0-dev (>= 2.40),
               libxrandr-dev,
               libddcutil5    (>= 2.1.0),
               libddcutil-dev (>= 2.1.0)
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://www.ddcutil.com

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqt5concurrent5  (>= 5.5),
         libqt5core5a       (>= 5.5),
         libqt5gui5         (>= 5.5),
         libqt5widgets5     (>= 5.5),
         libddcutil5        (>= 2.0.0)
Description: Control monitor settings
 Graphical User Interface for ddcutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.

## ddcui 0.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+set(ddcui_version  0.5.3)
+message(STATUS "ddcui_version:  ${ddcui_version}")
+
 cmake_minimum_required(VERSION 3.10)
 
 message(STATUS "cmake version: ${CMAKE_VERSION}")
@@ -8,16 +11,20 @@
    set(VERBOSE VERBOSE)
 endif()
 
-set(ddcui_qt_version         5.5)
+set(ddcui_qt5_min_version    5.5)
+set(ddcui_qt6_min_version    6.1)
 set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
-set(ddcui_libddcutil_version 2.0.0)
+set(ddcui_libddcutil_version 2.1.0)
 set(cmake_build_type_default "RelWithDebInfo")
 
 message(${VERBOSE} "Required Minimum Versions:")
-message(${VERBOSE} "  ddcui_qt_version:          ${ddcui_qt_version}" )
+message(${VERBOSE} "  ddcui_qt5_min_version:     ${ddcui_qt5_min_version}" )
 message(${VERBOSE} "  ddcui_qlib_version:        ${ddcui_glib_version}" )
 message(${VERBOSE} "  ddcui_libddcutil_version:  ${ddcui_libddcutil_version}" ) 
 
+option(USE_QT6 "Use QT6 instead of QT5" OFF)
+message(STATUS "USE_QT6:      ${USE_QT6}")
+
 option(USE_CCACHE "Use ccache" ON)
 message(STATUS "USE_CCACHE:                ${USE_CCACHE}" )
 
@@ -31,7 +38,7 @@
 
 include(validate_CMAKE_BUILD_TYPE)
 
-project(ddcui VERSION 0.5.0 LANGUAGES C CXX)
+project(ddcui VERSION ${ddcui_version} LANGUAGES C CXX)
 
 message(STATUS "Build type is: ${CMAKE_BUILD_TYPE} (CMAKE_BUILD_TYPE)")
 message(${VERBOSE} "   CMAKE_C_COMPILER:               ${CMAKE_C_COMPILER}" )
@@ -52,21 +59,22 @@
 message(STATUS "Source directory: ${CMAKE_SOURCE_DIR} (CMAKE_SOURCE_DIR)" )
 message(STATUS "Build directory:  ${CMAKE_BINARY_DIR} (CMAKE_BINARY_DIR)" )
 
-  execute_process(
-      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-      COMMAND git branch --show-current 2>/dev/null
-      OUTPUT_VARIABLE DDCUI_GIT_BRANCH
-      RESULT_VARIABLE GIT_CMD_STATUS
-   )
-   # message (${VERBOSE} " result_variable: ${GIT_CMD_STATUS}")
-   if (${GIT_CMD_STATUS} STREQUAL "0")
-      string(LENGTH ${DDCUI_GIT_BRANCH} N)
-      math(EXPR lastpos "${N}-1")
-      string(SUBSTRING ${DDCUI_GIT_BRANCH} 0 ${lastpos} DDCUI_GIT_BRANCH)
-      message( ${VERBOSE} "ddcui git branch:   ${DDCUI_GIT_BRANCH}")
-   else() 
-      message( ${VERBOSE} "ddcui source is not managed by git")
-   endif()
+execute_process(
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    COMMAND git branch --show-current 2>/dev/null
+    OUTPUT_VARIABLE DDCUI_GIT_BRANCH
+    RESULT_VARIABLE GIT_CMD_STATUS
+)
+# message (${VERBOSE} " result_variable: ${GIT_CMD_STATUS}")
+if (${GIT_CMD_STATUS} STREQUAL "0")
+   string(LENGTH ${DDCUI_GIT_BRANCH} N)
+   math(EXPR lastpos "${N}-1")
+   string(SUBSTRING ${DDCUI_GIT_BRANCH} 0 ${lastpos} DDCUI_GIT_BRANCH)
+   message( ${VERBOSE} "ddcui git branch:   ${DDCUI_GIT_BRANCH}")
+else() 
+   message( ${VERBOSE} "ddcui source is not managed by git")
+endif()
+
 if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} ) 
    message(WARNING "Attempting to build in source directory.")
    if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
@@ -119,14 +127,25 @@
 message( ${VERBOSE} "  CMAKE_AUTORCC:           ${CMAKE_AUTORCC}")
 # message( ${VERBOSE} "AUTOGEN_BUILD_DIR:       ${AUTOGEN_BUILD_DIR}") overrides default location
 
-set(QT5_LIBRARIES Qt5::Widgets )
-# Ensures all Qt componenets have same version: 
-find_package(Qt5 ${ddcui_qt_version} COMPONENTS Core Widgets Gui Help REQUIRED)
-message( ${VERBOSE} "Qt directories:")
-message( ${VERBOSE} "  Qt5Widgets_INCLUDE_DIRS:  ${Qt5Widgets_INCLUDE_DIRS}" )
-message( ${VERBOSE} "  Qt5Core_INCLUDE_DIRS:     ${Qt5Core_INCLUDE_DIRS}"    )
-message( ${VERBOSE} "  Qt5Gui_INCLUDE_DIRS:      ${Qt5Gui_INCLUDE_DIRS}"     )
-message( ${VERBOSE} "  Qt5Help_INCLUDE_DIRS:     ${Qt5Help_INCLUDE_DIRS}"    )
+if (USE_QT6)
+   set(QT6_LIBRARIES Qt6::Widgets )
+   # Ensures all Qt componenets have same version: 
+   find_package(Qt6 ${ddcui_qt6_min_version} COMPONENTS Core Widgets Gui Help REQUIRED)
+   message( ${VERBOSE} "Qt directories:")
+   message( ${VERBOSE} "  Qt6Widgets_INCLUDE_DIRS:  ${Qt6Widgets_INCLUDE_DIRS}" )
+   message( ${VERBOSE} "  Qt6Core_INCLUDE_DIRS:     ${Qt6Core_INCLUDE_DIRS}"    )
+   message( ${VERBOSE} "  Qt6Gui_INCLUDE_DIRS:      ${Qt6Gui_INCLUDE_DIRS}"     )
+   message( ${VERBOSE} "  Qt6Help_INCLUDE_DIRS:     ${Qt6Help_INCLUDE_DIRS}"    )
+else()
+   set(QT5_LIBRARIES Qt5::Widgets )
+   # Ensures all Qt componenets have same version: 
+   find_package(Qt5 ${ddcui_qt5_min_version} COMPONENTS Core Widgets Gui Help REQUIRED)
+   message( ${VERBOSE} "Qt directories:")
+   message( ${VERBOSE} "  Qt5Widgets_INCLUDE_DIRS:  ${Qt5Widgets_INCLUDE_DIRS}" )
+   message( ${VERBOSE} "  Qt5Core_INCLUDE_DIRS:     ${Qt5Core_INCLUDE_DIRS}"    )
+   message( ${VERBOSE} "  Qt5Gui_INCLUDE_DIRS:      ${Qt5Gui_INCLUDE_DIRS}"     )
+   message( ${VERBOSE} "  Qt5Help_INCLUDE_DIRS:     ${Qt5Help_INCLUDE_DIRS}"    )
+endif()
 
 find_package (PkgConfig REQUIRED )
 pkg_check_modules(GLIB2 REQUIRED glib-2.0>=${ddcui_glib_version})
@@ -277,24 +296,3 @@
 
 # redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
 #            ${Qt5Help_INCLUDE_DIRS} is a superset of them all 
-target_include_directories(ddcui SYSTEM PRIVATE
-                                 ${Qt5Help_INCLUDE_DIRS}
-                                 ${GLIB2_INCLUDE_DIRS} 
-                                 ${DDCUTIL_INCLUDE_DIRS})
-
-target_include_directories(ddcui PRIVATE src)
-
-# Use the Widgets module from Qt 5.
-target_link_libraries(ddcui ${ASAN_LIBRARY} Qt5::Widgets ${GLIB2_LIBRARIES} ${DDCUTIL_LIBRARIES})
-
-get_property(dirs TARGET ddcui PROPERTY INCLUDE_DIRECTORIES)
-message( ${VERBOSE} "INCLUDE_DIRECTORIES:     ${dirs}" )
-message( ${VERBOSE} "Expanded:" )
-foreach(d ${dirs})
-  message(${VERBOSE} "  ${d}")
-endforeach()
-
-get_property(dirs TARGET ddcui PROPERTY LINK_DIRECTORIES)
-message( ${VERBOSE} "LINK_DIRECTORIES:     ${dirs}" )
-message( ${VERBOSE} "Expanded:" )
-foreach(d ${dirs})

=== debian/changelog ===
ddcui (0.5.3-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Wed, 08 Feb 2024 05:00:00 -0400

ddcui (0.5.2-1) focal; urgency=medium

  * New upstream release.

 -- Sanford Rockowitz <rockowitz@minsoft.com>  Sat, 27 Jan 2024 05:00:00 -0400

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
          libqt5core5a       (>= 5.5),
          libqt5gui5         (>= 5.5),
          libqt5widgets5     (>= 5.5),
-         libddcutil5        (>= 2.0.0)
+         libddcutil5        (>= 2.1.0)
 Description: Control monitor settings
  Graphical User Interface for ddcutil.
  .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# export DEB_LDFLAGS_MAINT_APPEND = -W1, --as-needed

#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs -k  CHANGELOG.md

override_dh_auto_configure:
	dh_auto_configure -- --log-level=VERBOSE

# override_dh_shlibdeps:
# 	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## ddcui 0.5.4

=== debian/changelog ===
ddcui (0.5.4-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 14 Dec 2024 00:53:16 -0800

ddcui (0.5.4-2) unstable; urgency=medium

  * 'd/control': Adoption, add myself as maintainer. (Closes: #1080173)
  * Add Debian Continuous Integration (CI) file: 'd/salsa-ci.yml'.
  * 'd/rules': Add DH_VERBOSE, but have disabled by default.

 -- Phil Wyett <philip.wyett@kathenas.org>  Tue, 10 Sep 2024 15:09:51 +0100

ddcui (0.5.4-1) unstable; urgency=medium

  * QA upload.
  * Package orphaned.
  * New upstream version 0.5.4.
  * Remove 'd/compat'.
  * 'd/control':
    - Change maintainer to QA group.
    - Use HTTPS for 'Homepage'.
    - Update 'Standards-Version' to 4.7.0, no changes required.
    - Remove versioned build dependencies.
    - Remove 'libddcutil4' build dependency.
    - Update obsolete build dependency 'pkg-config => pkgconf'.
    - Use 'debhelper-compat' 13.
    - Add Vcs fields.
  * 'd/rules' - Remove 'override_dh_auto_configure' block.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sun, 08 Sep 2024 10:46:47 +0100

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-Wall -pedantic

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs -k  CHANGELOG.md

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## ddcui 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-set(ddcui_version  0.5.3)
+set(ddcui_version  0.6.0)
 message(STATUS "ddcui_version:  ${ddcui_version}")
 
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.15)
 
 message(STATUS "cmake version: ${CMAKE_VERSION}")
 # message(VERBOSE) requires cmake 3.15
@@ -13,8 +13,8 @@
 
 set(ddcui_qt5_min_version    5.5)
 set(ddcui_qt6_min_version    6.1)
-set(ddcui_glib_version       2.40)   # g_option_context_parse_strv() new in 2.40
-set(ddcui_libddcutil_version 2.1.0)
+set(ddcui_glib_version       2.60) 
+set(ddcui_libddcutil_version 2.2.0)
 set(cmake_build_type_default "RelWithDebInfo")
 
 message(${VERBOSE} "Required Minimum Versions:")
@@ -192,15 +192,21 @@
 configure_file(cconfig.h.in config.h)
 
 set(SOURCES
+    src/c_util/common_inlines.h
+    src/c_util/common_printf_formats.h
+    src/c_util/backtrace.c
     src/c_util/data_structures.c
     src/c_util/ddcutil_config_file.c
     src/c_util/debug_util.c
     src/c_util/error_info.c
     src/c_util/file_util_base.c
     src/c_util/glib_util.c
+    src/c_util/msg_util.c
     src/c_util/report_util.c
     src/c_util/simple_ini_file.c
     src/c_util/string_util.c
+    src/c_util/traced_function_stack.c
+    src/c_util/timestamp.c
     src/c_util/xdg_util.c
 
     src/base/ddcui_core_aux.c
@@ -268,6 +274,7 @@
     src/main/mainwindow_ui.cpp
     src/main/monitor.cpp 
     src/main/msgbox_thread.cpp
+	src/main/callback_manager.cpp
 )
 
 # file(GLOB dummy_SOURCES src/dummies/*.cpp)
@@ -292,7 +299,3 @@
 # -Wno-format-pedantic -Wno-sign-compare -std=c++20 -Wno-format -pedantic -Wextra -Wall
 # set(more_options -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-non-pod-varargs  )
 target_compile_options(ddcui PUBLIC "-fPIC" ${coverity_cflags} ${asan_flags})
-# add_compile_options(-Og -H V=1)
-
-# redundant: ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS}. 
-#            ${Qt5Help_INCLUDE_DIRS} is a superset of them all

=== debian/changelog ===
ddcui (0.6.0-5) unstable; urgency=medium

  * 'debian/watch':
    - Make 'Version: 5' its own paragraph.

 -- Phil Wyett <philip.wyett@kathenas.org>  Tue, 09 Sep 2025 12:33:37 +0100

ddcui (0.6.0-4) unstable; urgency=medium

  * 'debian/changelog'
    - Fix typo.

 -- Phil Wyett <philip.wyett@kathenas.org>  Wed, 03 Sep 2025 10:04:26 +0100

ddcui (0.6.0-3) unstable; urgency=medium

  * 'debian/control':
    - Remove not need 'Rules-Requires-Root: no'.
    - Remove version requirement on 'libddcutil-dev' 'Build-Depends'.

 -- Phil Wyett <philip.wyett@kathenas.org>  Fri, 29 Aug 2025 21:39:34 +0100

ddcui (0.6.0-2) unstable; urgency=medium

  * 'debian/control':
    - Update to 'Standards-Version' 4.7.2, no changes required.
  * 'debian/watch':
    - Update to version 5.

 -- Phil Wyett <philip.wyett@kathenas.org>  Thu, 28 Aug 2025 11:16:17 +0100

ddcui (0.6.0-1) unstable; urgency=medium

  * New upstream release, 0.6.0.
  * 'd/control':
    - Add minimum version for 'libddcutil-dev' 'Build-Depends'.
    - Update 'Standards-Version' to 4.7.1, no changes required.
  * 'd/copyright':
    - Update year for my entry in 'Files: debian/*' section.
  * Add simple 'd/gbp.conf' to start us off.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sat, 22 Feb 2025 19:01:55 +0000

=== debian/control ===
Source: ddcui
Priority: optional
Section: utils
Maintainer: Phil Wyett <philip.wyett@kathenas.org>
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               cmake,
               libglib2.0-dev,
               libxrandr-dev,
               qtbase5-dev,
               qttools5-dev,
               libddcutil-dev
Standards-Version: 4.7.2
Homepage: https://www.ddcutil.com
Vcs-Git: https://salsa.debian.org/debian/ddcui.git
Vcs-Browser: https://salsa.debian.org/debian/ddcui

Package: ddcui
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GUI for ddcutil
 This package provides a graphical user interface for ddccutil.
 .
 ddcutil communicates with monitors implementing MCCS (Monitor Control Command
 Set). Normally, communication is performed using the DDC/CI protocol on the
 I2C bus.  Alternatively, communication can be performed over USB as per the
 USB Monitor Control Class Specification.

=== debian/rules ===
--- 
+++ 
@@ -11,8 +11,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k  CHANGELOG.md
-
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
Version: 5

Template: Github
Owner: rockowitz
Project: ddcui
